Subject: git-commit goes awry after git-add -u

From: Salikh Zakirov <[email-masked]>
Date: Wed, 15 Aug 2007 23:16:59 +0900

Hi,

I have observed incorret behaviour of git-commit after git-add -u, where
it records deletions of files not related to the files touched by commit.

Unfortunately, I was not able to create a small reproducer, and so
describing the reproducer with the codebase I've encountered this.
Fortunately, it's an open-source project, so I've uploaded the tree
to repo.or.cz.

I've reproduced the problem with both 1.5.3-rc5 and 1.5.2.4

The problematic commit is the topmost one, so it is needed to reset it
to reproduce the bug. The commit moves files:

  vm/em/src/ia32 => vm/em/src/arch/ia32
  vm/vmcore/src/util/em64t => vm/em/src/arch/em64t
  vm/vmcore/src/util/ipf => vm/em/src/arch/ipf

Problem description (short):

Sequence of commands
 git-add -u
 git-commit
produces severely damaged commit. If 'git-add -u' is changed
to using git-add and git-rm, the commit is correct.

How to reproduce (long):

$ git clone git://repo.or.cz/drlvm.git
$ cd drlvm
$ git reset HEAD^   	# undo the problematic commit
$ git status		# all is good now
...
# Changed but not updated:
...
#       deleted:    vm/em/src/ia32/...
...
#       deleted:    vm/vmcore/src/util/em64t/...
...
#       deleted:    vm/vmcore/src/util/ipf/...
...
# Untracked files:
...
#       vm/em/src/arch/

$ git add vm/em/src/arch/	# inform git about added files
$ git status		# still good...
...
# Changes to be committed:
...
#       new file:   vm/em/src/arch/...
...
# Changed but not updated:
...
#       deleted:    vm/em/src/ia32/...
...
#       deleted:    vm/vmcore/src/util/em64t/...
...
#       deleted:    vm/vmcore/src/util/ipf/...
...
$ git add -u		# inform git about deleted files as well
$ git status		# output is okay, it looks like git picked up all of the
moves, but ...
...
# Changed but not updated:
#       renamed:    vm/vmcore/src/util/em64t/... -> vm/em/src/arch/em64t/...
...
$ git diff		# is empty as expected
$ git diff -M --cached  # shows a bunch of renames as expected
$ git commit -m "move"  # BANG! something gone wrong:
Created commit 64aed27: move
 53 files changed, 23168 insertions(+), 5414 deletions(-)
 create mode 100644 vm/em/src/arch/...
 ...					# file creations are okay
 delete mode 100644 vm/vmi/Makefile	# these deletions are incorrect
 delete mode 100644 vm/vmi/src/j9vmls.cpp
 delete mode 100644 vm/vmi/src/vm_trace.h
 delete mode 100644 vm/vmi/src/vmi.cpp
 delete mode 100644 vm/vmi/src/vmi.exp
 delete mode 100644 vm/vmstart/src/compmgr/component_manager_impl.cpp
 delete mode 100644 vm/vmstart/src/compmgr/component_manager_impl.h

$ git status		# work dir is expected to be clean, but it is not
# Changes to be committed:
...
#       deleted:    vm/vmcore/src/util/em64t/...	
...
#       new file:   vm/vmi/Makefile
#       new file:   vm/vmi/src/j9vmls.cpp
#       renamed:
vm/vmcore/src/util/em64t/base_natives/java_lang_thread_em64t.cpp ->
vm/vmi/src/vm_trace.h
#       new file:   vm/vmi/src/vmi.cpp
#       new file:   vm/vmi/src/vmi.exp
#       new file:   vm/vmstart/src/compmgr/component_manager_impl.cpp
#       new file:   vm/vmstart/src/compmgr/component_manager_impl.h

So it does not committed deletion of moved files, but instead recorded
deletions of some other arbitrary files, which in fact are still intact
in the tree, and now are reported as new.

Alternative sequence of commands, not involving 'git-add -u' produces
correct results (without output for compactness)
$ git add vm/em
$ git rm -r vm/vmcore/src/util/ipf
$ git rm -r vm/vmcore/src/util/em64t
$ git rm -r vm/em/src/ia32
$ git status
# On branch master
nothing to commit (working directory clean)